/*
 * Copyright (C) 2011 Kouichi Machida (k01-dev@live.jp)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.gr.java_conf.k01.android.widgetpack.preference;

import jp.gr.java_conf.k01.android.widgetpack.R;
import android.app.AlertDialog;
import android.content.Context;
import android.content.res.TypedArray;
import android.preference.Preference;
import android.util.AttributeSet;

/**
 * IƃbZ[W{bNX\ DialogPreference B
 * 
 * @author Kouichi Machida
 */
public class MessageBoxPreference extends Preference {

	/**
	 * \bZ[Wێ܂B
	 */
	private String message;

	/**
	 * \^Cgێ܂B
	 */
	private String title;

	/**
	 * MessageBoxDialogPreference NX̐VCX^X܂B
	 * 
	 * @param context
	 *            Context IuWFNgB
	 */
	public MessageBoxPreference(Context context) {
		super(context);
	}

	/**
	 * MessageBoxDialogPreference NX̐VCX^X܂B
	 * 
	 * @param context
	 *            Context IuWFNgB
	 * @param attrs
	 *            AttributeSet IuWFNgB
	 */
	public MessageBoxPreference(Context context, AttributeSet attrs) {
		super(context, attrs);

		this.init(context, attrs);
	}

	/**
	 * MessageBoxDialogPreference NX̐VCX^X܂B
	 * 
	 * @param context
	 *            Context IuWFNgB
	 * @param attrs
	 *            AttributeSet IuWFNgB
	 * @param defStyle
	 */
	public MessageBoxPreference(Context context, AttributeSet attrs, int defStyle) {
		super(context, attrs, defStyle);

		this.init(context, attrs);
	}

	/**
	 * CX^X܂B
	 * 
	 * @param context
	 *            Context IuWFNgB
	 * @param attrs
	 *            AttributeSet IuWFNgB
	 */
	private void init(Context context, AttributeSet attrs) {
		// TypedArray ܂B
		TypedArray typedArray = context.obtainStyledAttributes(attrs, R.styleable.MessageBoxPreference);

		this.title = typedArray.getString(R.styleable.MessageBoxPreference_title);
		this.message = typedArray.getString(R.styleable.MessageBoxPreference_message);

		typedArray.recycle();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.preference.Preference#onClick()
	 */
	@Override
	protected void onClick() {
		super.onClick();

		AlertDialog.Builder builder = new AlertDialog.Builder(this.getContext());

		builder.setTitle(this.title);
		builder.setMessage(this.message);

		builder.show();
	}

}
